"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cancelAnimationFrame = cancelAnimationFrame;
exports.requestAnimationFrame = requestAnimationFrame;

var _register = require("./register");

var lastTime = 0;
var id = 0;

function hack(cb) {
  var now = Date.now();
  var nextTime = Math.max(lastTime + 23, now);
  id = setTimeout(function () {
    cb(lastTime = nextTime);
  }, nextTime - now);
  return id;
}

function requestAnimationFrame(cb) {
  var canvas = (0, _register.getCanvas)();

  if (canvas.requestAnimationFrame) {
    return canvas.requestAnimationFrame(cb);
  } else {
    return hack(cb);
  }
}

function cancelAnimationFrame(id) {
  var canvas = (0, _register.getCanvas)();

  if (canvas.cancelAnimationFrame) {
    return canvas.cancelAnimationFrame(id);
  } else {
    return clearTimeout(id);
  }
}
//# sourceMappingURL=requestAnimationFrame.js.map